//#include <iostream>
//#include <fstream>
//#include <vector>
//#include <algorithm>
//#include <queue>
//#include <cassert>
#include<bits/stdc++.h>
using namespace std;

static const int dx[4] = {-1, 0, 1, 0};
static const int dy[4] = {0, -1, 0, 1};

int minimum(const vector< vector<int> > &A, int G) {
    int N = A.size();
    vector< vector<int> > dist(N, vector<int>(N, numeric_limits<int>::max() / 2));

    queue< pair<int, int> > current, next;
    current.emplace(0, 0);
    dist[0][0] = int(A[0][0] < G);

    int current_cost = dist[0][0];
    while (current.size() || next.size()) {
        if (current.empty()) {
            current.swap(next);
            ++current_cost;
            continue;
        }
        int x, y; tie(x, y) = current.front();
        current.pop();
        if (dist[x][y] != current_cost)
            continue;
        for (int k = 0; k < 4; ++k) {
            int newx = x + dx[k];
            int newy = y + dy[k];
            if (newx >= 0 && newy >= 0 && newx < N && newy < N)
                if (dist[newx][newy] > dist[x][y] + int(A[newx][newy] < G)) {
                    dist[newx][newy] = dist[x][y] + int(A[newx][newy] < G);
                    if (A[newx][newy] < G)
                        next.emplace(newx, newy);
                    else
                        current.emplace(newx, newy);
                }
        }
    }
    return dist[N - 1][N - 1];
}

int main() {
    ifstream cin("rover.in");
    ofstream cout("rover.out");

    int V; assert(cin >> V);
    assert(1 <= V && V <= 2);
    int N, G; assert(cin >> N);
    assert(1 <= N && N <= 1000);
    if (V == 1) {
        assert(cin >> G);
        assert(1 <= G && G <= 5000);
    }

    vector< vector<int> > A(N, vector<int>(N));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j) {
            assert(cin >> A[i][j]);
            assert(0 <= A[i][j] && A[i][j] <= 10000);
        }

    if (V == 1) {
        assert(A[0][0] >= G && A[N - 1][N - 1] >= G);
        cout << minimum(A, G) << "\n";
        return 0;
    }

    int answer;
    int max_value = 0;
    for (auto &line : A)
        for (auto &v : line)
            max_value = max(max_value, v);
    int step;
    for (step = 1; step < max_value; step <<= 1);
    for (answer = 0; step; step >>= 1)
        if (minimum(A, answer + step) == 0)
            answer += step;
    cout << answer << "\n";
}
