#include <cstdio>
#include <vector>

using namespace std;

int n;
vector<long long> divisors;
vector<int> primes, powers;

void back(int pos, long long val)
{
    if (pos == primes.size())
    {
        divisors.push_back(val);
        return;
    }

    for (int i = 0; i <= powers[pos]; ++i)
    {
        back(pos + 1, val);
        val *= primes[pos];
    }
}

void getDivisorsOfN2(long long n)
{
    for (int i = 2; 1LL * i * i <= n; ++i)
    {
        if (n % i == 0)
        {
            int power = 0;
            while (n % i == 0)
            {
                n /= i;
                power += 2;
            }
            primes.push_back(i);
            powers.push_back(power);
        }
    }

    if (n > 1)
    {
        primes.push_back(n);
        powers.push_back(2);
    }

    back(0, 1);
}

int main()
{
    freopen("armonica.in", "r", stdin);
    freopen("armonica.out", "w", stdout);

    scanf("%d", &n);

    if(n%2)
    {
        getDivisorsOfN2(n);
        printf("%d\n", divisors.size());
        for(auto dv : divisors)
        {
            long long d1 = dv;
            long long d2 = 1LL*n*n/dv;

            printf("%lld %lld\n", (n+d1)/2, (n+d2)/2);
        }
    }
    else
    {
        getDivisorsOfN2(n/2);
        printf("%d\n", divisors.size());
        for(auto dv : divisors)
        {
            long long d1 = dv;
            long long d2 = 1LL*n*n/4/dv;

            printf("%lld %lld\n", n/2+d1, n/2+d2);
        }
    }

    return 0;
}
