#include <bits/stdc++.h>

using namespace std;

int getCost(char c) {
    return c - 'A' + 1;
}

int getCost(string s) {
    int ret = 0;
    int p = 1;

    for(int i = 0; i < s.length(); ++i, p *= 5) {
        if (s[i] == 'E')
            continue;
        ret += p * getCost(s[i]);
    }

    return ret;
}

struct Edge {
    int f, t;
    int cost;
    int E;

    Edge(int f, int t, string str):
    f(f),
    t(t),
    cost(getCost(str)),
    E(0)
    {
        for(auto c: str)
            E += (c == 'E');
    }

    pair<int, int> asECost() const {
        return {E, cost};
    }
};

int n, m;

vector<Edge> E;

vector<int> under;
vector<int> TT;

int getUp(int nod)
{
    if (TT[nod] == nod)
        return nod;
    else
        return TT[nod] = getUp(TT[nod]);
}

bool unite(int x, int y)
{
    x = getUp(x);
    y = getUp(y);

    if (x == y)
        return false;

    if (under[x] >= under[y]) {
        TT[y] = x;
        under[x] += under[y];
        return true;
    } else {
        return unite(y, x);
    }
}

int countReachableFrom1()
{
    int ret = 0;
    for (int i = 1; i <= n; ++i) {
        ret += (getUp(i) == getUp(1));
    }
    return ret;
}

int main()
{
    ifstream in("ninjago.in");
    int v;

    in >> v;
    in >> n >> m;
    E.reserve(m);

    under.resize(n + 1);
    TT.resize(n + 1);
    for(int i = 1; i <= n; ++i) {
        under[i] = 1;
        TT[i] = i;
    }

    for (int i = 0; i < m; ++i) {
        int f, t;
        string s;
        in >> f >> t >> s;

        assert(1 <= f && f <= n);
        assert(1 <= t && t <= n);

        assert(s.length() == 4);

        for (auto c: s) {
            assert(strchr("ABCDE", c) != NULL);
        }

        E.push_back({f, t, s});
    }

    in.close();

    sort(E.begin(), E.end(), [](const Edge &a, const Edge &b) -> bool
        {
            return a.asECost() < b.asECost();
        });

    int energyUsed = 0;

    size_t at = 0;
    while (at < E.size() && E[at].E == 0) {
        if (unite(E[at].f, E[at].t)) {
            energyUsed += E[at].cost;
        }
        at++;
    }

    const int from1 = countReachableFrom1();

    int badEdges = 0;
    int takenEs = 0;
    while (at < E.size()) {
        bool used = unite(E[at].f, E[at].t);

        badEdges += used;
        takenEs += E[at].E * used;
        energyUsed += used * E[at].cost;
        at++;
    }


    ofstream out("ninjago.out");

    switch (v) {
        case 1:
            out << from1 << "\n";
            break;
        case 2:
            out << badEdges << "\n" << takenEs << "\n";
            break;
        case 3:
            out << energyUsed << "\n";
            break;
        default:
            assert(false);
            break;
    }
    return 0;
}
