#include <bits/stdc++.h>

using namespace std;

ofstream out("permutare.out");

const int MAX_N = 1000;
const int MAX_V = 2e9 + 10;

unsigned DP[MAX_N + 2][MAX_N + 2];

void precalc()
{
    for (int i = 1; i <= MAX_N; ++i) {
        DP[i][0] = 1;
        for (int j = 1; j <= i; ++j) {
            DP[i][j] = DP[i - 1][j] + DP[i][j - 1];

            if (DP[i][j] > MAX_V)
                DP[i][j] = MAX_V;
        }
    }
}

int fst[MAX_N + 1];
int snd[MAX_N + 1];

void solve1(int n, unsigned p)
{
    int i = 1, j = 1;
    int u = n, v = n;

    int at = 1;

    while (i <= n || j <= n) {
        if (p > DP[u][v - 1]) {
            p -= DP[u][v - 1];

            snd[j] = at;
            j++;

            u--;

        } else {
            fst[i] = at;
            i++;

            v--;
        }

        at++;

    }

    for (int i = 1; i <= n; ++i)
        out << fst[i] << " ";
    for (int i = 1; i <= n; ++i)
        out << snd[i] << " ";
    out << "\n";
}

void solve2(int n)
{
    int i = 1, j = 1;
    int at = 1;

    int u = n, v = n;

    int p = 1;

    while (i <= n || j <= n) {
        if (i <= n && at == fst[i]) {
            i++;

            v--;
        } else {
            assert(at == snd[j]);

            p += DP[u][v - 1];
            u--;
            j++;
        }


        at++;
    }

    out << p << "\n";
}

void process(const string &s)
{
    stringstream ss(s);

    int type;
    ss >> type;

    if (type == 1) {
        int n, p;
        ss >> n >> p;
        solve1(n, p);
    } else {
        int n;
        ss >> n;

        for(int i = 1; i <= n; ++i)
            ss >> fst[i];

        for(int i = 1; i <= n; ++i)
            ss >> snd[i];
        solve2(n);
    }
}

int main()
{
    precalc();

    ifstream in("permutare.in");
    string s;

    while (true) {
        getline(in, s);
        if (in.eof())
            break;

        process(s);
    }

    return 0;
}
