#include <vector>
#include <fstream>
#include <algorithm>
using namespace std;

bool isVisible(vector<vector<int>> &A, int p, int q, int i, int j) {
    int M = A.size(), N = A[0].size();
    int H = abs(A[p][q]);
    int h = abs(A[i][j]);
    int D = max(M-1-p, N-1-q);
    int d = max(M-1-i, N-1-j);
    return (D == 0 || H*d < D*h);
}

int countOnDirectionAndMark(vector<vector<int>> &A, int di, int dj) {
    int M = A.size(), N = A[0].size();
    int cnt = 0, highestI = M-1, highestJ = N-1;

    for (int i = M-1-di, j = N-1-dj; i >= 0 && j >= 0; A[i][j] *= -1, i -= di, j -= dj)
        if (isVisible(A, highestI, highestJ, i, j)) {
            cnt++; highestI = i; highestJ = j;
        }

    return cnt;
}

int main() {
    ifstream            f("ace.in");
    ofstream            g("ace.out");
    int                 T, M, N; f >> T >> M >> N;
    vector<vector<int>> A(M, vector<int>(N));

    for (int i = 0; i < M; i++)
        for (int j = 0; j < N; j++)
            f >> A[i][j];

    if (T == 1) {
        g << countOnDirectionAndMark(A, 1, 0) + countOnDirectionAndMark(A, 0, 1);
    }
    else {
        int ans = 0;
        for (int i = M-1; i >= 0; i--)
            for (int j = N-1; j >= 0; j--)
                if (A[i][j] >= 0 && (i != M-1 || j != N-1))
                    ans += countOnDirectionAndMark(A, M-1-i, N-1-j);
        g << ans;
    }

    return 0;
}

